import logging

import pygame


class GameState(object):
    def __init__(self, window, name, *args, **kwargs):
        self.window = window
        self.name = name
        self.update_rects = []
        self.log = logging.getLogger(self.name)
        self.log.info('++ Creating new {}'.format(self.name))

    def on_update(self, delta):
        return True

    def on_draw(self):
        return True

    def on_keydown(self, event):
        return True

    def on_keyup(self, event):
        return True

    def on_state_gain_focus(self):
        self.log.info('Gained Focus')
        return True

    def on_state_lose_focus(self):
        self.log.info('Lost Focus')
        return True

    def on_quit(self):
        self.window.running = False

    def on_window_gain_focus(self):
        pass

    def on_window_lose_focus(self):
        pass

    def on_mouse_motion(self, event):
        pass

    def on_mouse_button_down(self, event):
        pass

    def on_mouse_button_up(self, event):
        pass

    def on_window_resize(self, event):
        pass

    def on_draw(self):
        update_rects = []
        update_rects += self.scene.draw(self.window)
        pygame.display.update(update_rects)
